<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Get_AlarmMessages_V4 StructType
 * @subpackage Structs
 */
class Get_AlarmMessages_V4 extends AbstractStructBase
{
    /**
     * The OnlyVisiblePopups
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * - nillable: true
     * @var bool
     */
    public $OnlyVisiblePopups;
    /**
     * The Login
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\Login
     */
    public $Login;
    /**
     * The AlarmMessageSelection
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\AlarmMessageSelection
     */
    public $AlarmMessageSelection;
    /**
     * Constructor method for Get_AlarmMessages_V4
     * @uses Get_AlarmMessages_V4::setOnlyVisiblePopups()
     * @uses Get_AlarmMessages_V4::setLogin()
     * @uses Get_AlarmMessages_V4::setAlarmMessageSelection()
     * @param bool $onlyVisiblePopups
     * @param \StructType\Login $login
     * @param \StructType\AlarmMessageSelection $alarmMessageSelection
     */
    public function __construct($onlyVisiblePopups = null, \StructType\Login $login = null, \StructType\AlarmMessageSelection $alarmMessageSelection = null)
    {
        $this
            ->setOnlyVisiblePopups($onlyVisiblePopups)
            ->setLogin($login)
            ->setAlarmMessageSelection($alarmMessageSelection);
    }
    /**
     * Get OnlyVisiblePopups value
     * @return bool
     */
    public function getOnlyVisiblePopups()
    {
        return $this->OnlyVisiblePopups;
    }
    /**
     * Set OnlyVisiblePopups value
     * @param bool $onlyVisiblePopups
     * @return \StructType\Get_AlarmMessages_V4
     */
    public function setOnlyVisiblePopups($onlyVisiblePopups = null)
    {
        // validation for constraint: boolean
        if (!is_null($onlyVisiblePopups) && !is_bool($onlyVisiblePopups)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($onlyVisiblePopups, true), gettype($onlyVisiblePopups)), __LINE__);
        }
        $this->OnlyVisiblePopups = $onlyVisiblePopups;
        return $this;
    }
    /**
     * Get Login value
     * @return \StructType\Login|null
     */
    public function getLogin()
    {
        return $this->Login;
    }
    /**
     * Set Login value
     * @param \StructType\Login $login
     * @return \StructType\Get_AlarmMessages_V4
     */
    public function setLogin(\StructType\Login $login = null)
    {
        $this->Login = $login;
        return $this;
    }
    /**
     * Get AlarmMessageSelection value
     * @return \StructType\AlarmMessageSelection|null
     */
    public function getAlarmMessageSelection()
    {
        return $this->AlarmMessageSelection;
    }
    /**
     * Set AlarmMessageSelection value
     * @param \StructType\AlarmMessageSelection $alarmMessageSelection
     * @return \StructType\Get_AlarmMessages_V4
     */
    public function setAlarmMessageSelection(\StructType\AlarmMessageSelection $alarmMessageSelection = null)
    {
        $this->AlarmMessageSelection = $alarmMessageSelection;
        return $this;
    }
}
